#pragma once

#include <string>

#include "lwip/apps/http_client.h"
#include "pico/cyw43_arch.h"
//#include "pico/stdlib.h"

static char myHeaderBuffer[2048];
static char myBodyBuffer[2048];

void result_callback(void *arg, httpc_result_t httpc_result, u32_t rx_content_len,
                                u32_t srv_res, err_t err);

err_t headers_callback(httpc_state_t *connection, void *arg, struct pbuf *hdr,
                                  u16_t hdr_len, u32_t content_len);

err_t body_callback(void *arg, struct altcp_pcb *conn, struct pbuf *p, err_t err);

class HttpClient {
  public:
    HttpClient();
    std::string retrieveWasteDatesAsCsv();
    bool m_received{false};

  private:
    httpc_connection_t m_settings;
};
